# Library Sandbox

## Assembly
 - A beamer and a monitor must be pluged to the pc (2 outputs needed for the calibration)
 - The camera must be pluged with an usb 3.0 extension (otherwise the resolution of the frames will be lowered)

## Depedencies
 - OS : Arch (Endeavour), Ubuntu
 - C++ : 11.0
 - g++ : 7.5.0
 - OpenCV : 4.x.x
 - librealsense 2 : 2.x.x
 - yaml-cpp : https://github.com/jbeder/yaml-cpp (latest)
 - Qt : 5.9.5

## Makefile for applications
Examples can be found in the project ar_sandbox_app

## Installation
 - run `mkdir build` if build directory does not exist and `cd` into it.
 - in build directory, run `cmake ..`
 - in build directory run `cmake --build .`
     - Lib should be compiled in lib directory of the build directory.
     - If a problem arise, check if all dependencies are met.
 - to clean project run `cmake --build . --target clean`
 - to uninstall completly, delete build directory.

## Before launching your application
 - LD_LIBRARY_PATH must contain the path to the directory containing libsandbox.so (which is generated in /build)
 - Enter the command below in the terminal executing your applications
 - Where $REALTIVE_PATH_TO_SO is the relative path to the generated file libsandbox.so from the current path of your terminal

```
export LD_LIBRARY_PATH=$(pwd)/$RELATIVE_PATH_TO_SO
```
 - Don't forget that LD_LIBRARY_PATH is local to each terminal


If the ld variable is not set correctly or the library is not generated, this error will show up :
```
/usr/bin/ld : cannot find -lsandbox
collect2: error: ld returned 1 exit status
```
