#ifndef INITCAMERAGUI_H
#define INITCAMERAGUI_H

#include <QWidget>
#include <QTimer>
#include <QThread>
#include "subapp.h"
#include <sandboxSetup.h>

namespace Ui {
class InitCameraGui;
}


class CameraStartThread : public QThread
{
    Q_OBJECT

public:
    explicit CameraStartThread(Camera *c);
    void run();

signals:
    void setupReady(int err);

private:
    Camera *camera;
};



class InitCameraGui : public SubApp
{
    Q_OBJECT

public:
    explicit InitCameraGui(SandboxSetup *_setup, QWidget *parent = 0);
    ~InitCameraGui();

protected:
    void showEvent(QShowEvent *event);

private:
    Ui::InitCameraGui *ui;
    SandboxSetup *setup;
    CameraStartThread *workerThread;

    void setupCamera();
    void setupReady(int err);
};

#endif // INITCAMERAGUI_H
