#ifndef MONITORGUI_H
#define MONITORGUI_H

#include <QDialog>
#include <QtWidgets>
#include <string>
#include <sstream>
#include <vector>
#include <fstream>
#include <map>
#include <iostream>
#include <QScreen>

#include "subapp.h"
#include <sandboxSetup.h>

namespace Ui {
class MonitorGui;
}

class MonitorGui : public SubApp
{
    Q_OBJECT

public:
    explicit MonitorGui(SandboxSetup *_setup, QWidget *parent = 0);
    ~MonitorGui();

    int getHeight(){ return height; };
    int getWidth(){ return width; };
    std::string getOutput(){ return outputName.toStdString(); };
    QRect getResolution(){ return *resolution; }

    void valideRoutine();
    void cancelRoutine();

private slots:
    void on_cbxOutputs_currentIndexChanged(int index);

private:
    Ui::MonitorGui *ui;
    std::map<std::string, std::vector<std::string>> monitors;

    int height = 0;
    int width = 0;
    QString outputName = "";
    QRect *resolution;
    SandboxSetup *setup;

    QScreen* getMonitor();
    void loadResolutionsOf(QScreen* screen);
    std::vector<std::string> splitResolution(std::string s);
    bool isResolution(std::string s);
    void loadResolutionsFromFile(std::string path);
    void initMonitorMapWithFile(std::string path);
    void showMonitorsScreenshot(QScreen *screen);
};

#endif // MONITORGUI_H
