#ifndef PROJECTIONGUI_H
#define PROJECTIONGUI_H

#include <QDialog>
#include <sandboxSetup.h>
#include "monitorgui.h"
#include "qtfullscreen.h"

namespace Ui {
class ProjectionGui;
}

class ProjectionGui : public SubApp
{
    Q_OBJECT

public:
    explicit ProjectionGui(SandboxSetup *setup, MonitorGui *mg, QWidget *parent = 0);
    ~ProjectionGui();
    void valideRoutine();
    void cancelRoutine();

protected:
    void showEvent(QShowEvent *event);
    void closeEvent(QCloseEvent *event);

private:
    Ui::ProjectionGui *ui;
    SandboxSetup *setup;
    MonitorGui *mg;
    QTimer *frameTimer;
    QtFullScreen *blueScreen;
    bool cameraUsed = false;

    void startCapture();
    void closeCapture();
    void refreshFrame();
};

#endif // PROJECTIONGUI_H
